<template>
    <div class="home">
        <h1
            class="mb-2 text-4xl font-extrabold leading-none tracking-tight text-gray-900 md:text-3xl lg:text-4xl dark:text-lime-500 text-center">
            Encuentra tu Gif y agregalo a tus favoritos</h1>
        <p class="mb-2 text-center text-lg font-normal text-gray-500 lg:text-xl dark:text-gray-400">Ingresa lo que buscas y da <strong>clic sobre el gif</strong> para <strong>agregarlo</strong> a tus favoritos</p>
        <div class="text-center">
            <input v-model="searchText" type="text" class="required:border-red-500">
            <button @click=getGifs() class="button">Buscar</button>
        </div>
        <listGifsComponent :Gifs="this.Gifs" :Favoritos="this.favoritos"></listGifsComponent>
        <div class="text-center m-7">
            <p> Gifs encontrados: {{ this.total_count }} </p>
            <button class="button1" :disabled="!opatras" @click=atras()>Atras</button>
            <button class="button1" @click=siguiente()>Siguiente</button>
        </div>
    </div>
</template>
  
<script>
import listGifsComponent from '@/components/ListGifComponent.vue'

export default {
    name: 'HomeView',
    components: {
        listGifsComponent
    },
    data() {
        return {
            searchText: 'perrito',
            Gifs: [],
            offset: 0,
            total_count: 0,
            opatras: false,
            favoritos: [],
        };
    },
    created() {
        this.favoritos = this.$parent.itemsFromLocalStorage;
    },
    methods: {
        /**17/01/2024 KCASTILLO
         * consume API de gifs y obteniendo un JSON todos los parámetros son requeridos
         * @param id 
         */
        getGifs() {
            let urlstring = "https://api.giphy.com/v1/gifs/search?";
            let limit = 10;

            let url = `${urlstring}&api_key=${ process.env.VUE_APP_KEYGIPHY }&q=${this.searchText
                }&limit=${limit}&offset=${this.offset}`;
            this.$root.$emit('VisibleAlert', true, 'Espera un momento...');

            fetch(url)
                .then(response => {
                    return response.json();
                })
                .then(json => {
                    this.procesaData(json)
                    this.total_count = json.pagination.total_count;
                    setTimeout(() => this.$root.$emit('VisibleAlert', false, ''), 800)

                })
                .catch(err => {
                    console.log(err);
                    setTimeout(() => this.$root.$emit('VisibleAlert', false, ''), 800)
                });
        },
        /**17/01/2024 KCASTILLO
         * recorre un json para seleccionar el id y concatenarlo con una url necesaria para visualizar los gifs.
         * @param id 
         */
        procesaData(json) {
            this.Gifs = json.data
                .map(gif => gif.id,)
                .map(gifId => {
                    return `https://media.giphy.com/media/${gifId}/giphy.gif`;
                });
            console.log("procesaGifs" + this.Gifs);
        },
        siguiente() {

            this.offset++;
            this.getGifs();
            this.validaAtras();
        },
        atras() {
            this.offset--;
            this.getGifs();
            this.validaAtras();
        },
        validaAtras() {
            console.log(this.offset);
            if (this.offset > 0) {
                this.opatras = true;
            } else {
                this.opatras = false;
            }
        }
    }
}
</script>
<style scoped>
input {
    border: 1px solid #04AA6D;
    padding: 4px 32px 4px 2px !important;
    margin-bottom: auto !important;
    font-size: 18px !important;
}

.button {
    background-color: rgb(0, 172, 0);
    color: white;
    padding: 8px 32px;
    font-size: 16px;
    border: none;
    display: left;
    margin: 0 auto;
}

.button-add {
    border: 1px solid rgb(0, 172, 0);
    padding: 8px 32px;
    font-size: 16px;
    color: rgb(0, 172, 0);
    margin-left: 5px;
    margin-right: 5px;
}

.button1 {
    border: 1px solid #04AA6D;
    padding: 8px 32px;
    font-size: 16px;
    color: black;
    margin-left: 5px;
    margin-right: 5px;
}

.button:hover {
    background-color: rgb(0, 148, 0);
}

.gif-container {
    margin-top: 30px;
    display: flex;
    flex-direction: column;
    align-items: center;
}
</style>